<!-- -*- mode: markdown; mode: flyspell -*- -->

# bash-crypto library

A bash library for cryptographic and related stuff.

## Dependencies

bash-crypto depends on bash-base and openssl.

## API Documentation

The API Documentation can be found in [API.md](API.md).

## Using bash-crypto

### Loading the Library

With loaded bash-base and system wide installed bash-crypto all you have
to do is:
```
bb_require_libs bash-crypto
```

Note: Using `bb_require_libs` will raise an fatal error if the library
could not be loaded. Use e.g. `bb_load_lib` to react on any error
while loading it.

## Namespace

All global variables and functions of bash-crypto start with either
`bcr_` or `_bcr_`. Functions starting with `_bcr_` are for
internal use only and their API might change without warning.

Function that take variable names as arguments will not accept
variable names starting with `_`. Local variables in bash-crypto
function will always start with `_` or with the full function
name. That ensures that passed variable names will not be shadowed by
local variables inside the called function.

<!--  LocalWords: CRYPTO crypto Namespace API cryptographic openssl
 -->
